import { CLIAction } from './action';
import { CliApiObject, ParsedParameters } from './cli';
import { Parameter, ParameterName, ParameterOverridenConfig } from './parameter';
export declare type CommandName = string;
export interface CommandDescriptor {
    name: CommandName;
    parameters: (ParameterName | ParameterOverridenConfig)[];
    action: CLIAction;
}
export declare const programApi: CliApiObject;
export declare function assertConjunctionParameters(commandDescriptor: CommandDescriptor, options: any): void;
export declare function assertRequired(parameter: Parameter, options: any): void;
export declare function assertForbidden(parameter: Parameter, options: any): void;
export declare class CLICommand {
    readonly commandDescription: CommandDescriptor;
    private static allCommandInstances;
    /**
     * @param {CommandDescriptor} commandDescription an immutable representation of a command
     * @param {string[]} argv a custom argv for testing purposes
     */
    constructor(commandDescription: CommandDescriptor, program?: CliApiObject);
    get action(): Promise<ParsedParameters>;
    static parse(program?: CliApiObject, argv?: string[]): void;
    private static rejectNonTriggeredAwaiters;
    /**
     * @returns {CommandDescriptor[]} all declared command descriptors
     */
    static getAllCommandDescriptors(): CommandDescriptor[];
}
