"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ardrive_core_js_1 = require("ardrive-core-js");
const __1 = require("..");
const CLICommand_1 = require("../CLICommand");
const action_1 = require("../CLICommand/action");
const error_codes_1 = require("../CLICommand/error_codes");
const parameter_declarations_1 = require("../parameter_declarations");
const get_arweave_for_url_1 = require("../utils/get_arweave_for_url");
new CLICommand_1.CLICommand({
    name: 'get-balance',
    parameters: [...parameter_declarations_1.WalletTypeParameters, parameter_declarations_1.AddressParameter, parameter_declarations_1.GatewayParameter],
    action: new action_1.CLIAction(function action(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const parameters = new CLICommand_1.ParametersHelper(options);
            const arweave = get_arweave_for_url_1.getArweaveFromURL(parameters.getGateway());
            const address = yield parameters.getWalletAddress();
            const walletDAO = __1.cliWalletDAOFactory(arweave);
            const balanceInWinston = yield walletDAO.getAddressWinstonBalance(address);
            const balanceInAR = new ardrive_core_js_1.AR(balanceInWinston);
            console.log(`${balanceInWinston}\tWinston`);
            console.log(`${balanceInAR}\tAR`);
            return error_codes_1.SUCCESS_EXIT_CODE;
        });
    })
});
