"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ardrive_core_js_1 = require("ardrive-core-js");
const __1 = require("..");
const CLICommand_1 = require("../CLICommand");
const action_1 = require("../CLICommand/action");
const parameter_declarations_1 = require("../parameter_declarations");
const get_arweave_for_url_1 = require("../utils/get_arweave_for_url");
new CLICommand_1.CLICommand({
    name: 'get-drive-key',
    parameters: [...parameter_declarations_1.DriveCreationPrivacyParameters, parameter_declarations_1.DriveIdParameter, parameter_declarations_1.NoVerifyParameter, parameter_declarations_1.GatewayParameter],
    action: new action_1.CLIAction(function action(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const parameters = new CLICommand_1.ParametersHelper(options);
            const driveId = ardrive_core_js_1.EID(parameters.getRequiredParameterValue(parameter_declarations_1.DriveIdParameter));
            const driveKey = yield parameters.getDriveKey({ driveId });
            if (options.verify) {
                const arweave = get_arweave_for_url_1.getArweaveFromURL(parameters.getGateway());
                const arDrive = __1.cliArDriveFactory({ wallet: yield parameters.getRequiredWallet(), arweave });
                yield arDrive.getPrivateDrive({ driveId, driveKey });
            }
            console.log(driveKey.toJSON());
        });
    })
});
