"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CLICommand_1 = require("../CLICommand");
const action_1 = require("../CLICommand/action");
const error_codes_1 = require("../CLICommand/error_codes");
const parameter_declarations_1 = require("../parameter_declarations");
const axios_1 = __importDefault(require("axios"));
function lastTxForAddress(gateway, address) {
    return __awaiter(this, void 0, void 0, function* () {
        const response = yield axios_1.default.get(`${gateway.href}wallet/${address}/last_tx`);
        return `${response.data}`;
    });
}
new CLICommand_1.CLICommand({
    name: 'last-tx',
    parameters: [...parameter_declarations_1.WalletTypeParameters, parameter_declarations_1.AddressParameter, parameter_declarations_1.GatewayParameter],
    action: new action_1.CLIAction(function action(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const parameters = new CLICommand_1.ParametersHelper(options);
            const gateway = parameters.getGateway();
            const walletAddress = yield parameters.getWalletAddress();
            const lastTx = yield lastTxForAddress(gateway, walletAddress);
            console.log(lastTx);
            return error_codes_1.SUCCESS_EXIT_CODE;
        });
    })
});
