"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const CLICommand_1 = require("../CLICommand");
const parameter_declarations_1 = require("../parameter_declarations");
const fs = __importStar(require("fs"));
const transaction_1 = __importDefault(require("arweave/node/lib/transaction"));
const crypto = __importStar(require("crypto"));
const error_codes_1 = require("../CLICommand/error_codes");
const action_1 = require("../CLICommand/action");
const ardrive_core_js_1 = require("ardrive-core-js");
const get_arweave_for_url_1 = require("../utils/get_arweave_for_url");
new CLICommand_1.CLICommand({
    name: 'send-tx',
    parameters: [parameter_declarations_1.TxFilePathParameter, parameter_declarations_1.DryRunParameter, parameter_declarations_1.GatewayParameter],
    action: new action_1.CLIAction(function action(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const parameters = new CLICommand_1.ParametersHelper(options);
            const transaction = new transaction_1.default(JSON.parse(fs.readFileSync(parameters.getRequiredParameterValue(parameter_declarations_1.TxFilePathParameter)).toString()));
            const srcAddress = ardrive_core_js_1.bufferTob64Url(crypto.createHash('sha256').update(ardrive_core_js_1.b64UrlToBuffer(transaction.owner)).digest());
            const arweave = get_arweave_for_url_1.getArweaveFromURL(parameters.getGateway());
            console.log(`Source address: ${srcAddress}`);
            console.log(`AR amount sent: ${arweave.ar.winstonToAr(transaction.quantity)}`);
            console.log(`Destination address: ${transaction.target}`);
            const response = yield (() => __awaiter(this, void 0, void 0, function* () {
                if (parameters.isDryRun()) {
                    return { status: 200, statusText: 'OK', data: '' };
                }
                else {
                    return yield arweave.transactions.post(transaction);
                }
            }))();
            if (response.status === 200 || response.status === 202) {
                console.log(JSON.stringify({
                    txID: transaction.id,
                    winston: transaction.quantity,
                    reward: transaction.reward
                }, null, 4));
                return error_codes_1.SUCCESS_EXIT_CODE;
            }
            else {
                console.log(`Failed to send tx with error: ${response.statusText}`);
            }
            return error_codes_1.ERROR_EXIT_CODE;
        });
    })
});
