#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cliArDriveAnonymousFactory = exports.cliArDriveFactory = exports.cliWalletDAOFactory = exports.cliWalletDao = exports.cliArweave = exports.CLI_APP_VERSION = exports.CLI_APP_NAME = void 0;
const arweave_1 = __importDefault(require("arweave"));
const CLICommand_1 = require("./CLICommand");
const ardrive_core_js_1 = require("ardrive-core-js");
const arfs_tag_settings_1 = require("ardrive-core-js/lib/arfs/arfs_tag_settings");
// eslint-disable-next-line @typescript-eslint/no-var-requires
const { version: CLI_APP_VERSION } = require('../package.json');
exports.CLI_APP_VERSION = CLI_APP_VERSION;
if (require.main === module) {
    // declare all parameters
    Promise.resolve().then(() => __importStar(require('./parameter_declarations'))).then(() => {
        // declares the commands
        Promise.resolve().then(() => __importStar(require('./commands'))).then(() => {
            try {
                CLICommand_1.CLICommand.parse();
            }
            catch (_a) {
                // do nothing, commander already logs the error
            }
        });
    });
}
exports.CLI_APP_NAME = 'ArDrive-CLI';
// TODO: Make configurable from CLI
exports.cliArweave = arweave_1.default.init({
    host: 'arweave.net',
    //host: 'arweave.dev', // Arweave Dev Gateway
    port: 443,
    protocol: 'https',
    timeout: 600000
});
exports.cliWalletDao = new ardrive_core_js_1.WalletDAO(exports.cliArweave, exports.CLI_APP_NAME, CLI_APP_VERSION);
const cliWalletDAOFactory = (arweave = exports.cliArweave) => new ardrive_core_js_1.WalletDAO(arweave, exports.CLI_APP_NAME, CLI_APP_VERSION);
exports.cliWalletDAOFactory = cliWalletDAOFactory;
const cliArDriveFactory = ({ appName = exports.CLI_APP_NAME, appVersion = CLI_APP_VERSION, arweave = exports.cliArweave, walletDao = exports.cliWalletDAOFactory(arweave), dryRun, feeMultiple, wallet, arfsDao, communityOracle, priceEstimator, shouldBundle = true, arFSTagSettings = new arfs_tag_settings_1.ArFSTagSettings({ appName, appVersion }), uploadPlanner }) => ardrive_core_js_1.arDriveFactory({
    appName,
    appVersion,
    arweave,
    walletDao,
    dryRun,
    feeMultiple,
    wallet,
    arfsDao,
    communityOracle,
    priceEstimator,
    shouldBundle,
    arFSTagSettings,
    uploadPlanner
});
exports.cliArDriveFactory = cliArDriveFactory;
const cliArDriveAnonymousFactory = ({ arweave = exports.cliArweave }) => ardrive_core_js_1.arDriveAnonymousFactory({
    arweave
});
exports.cliArDriveAnonymousFactory = cliArDriveAnonymousFactory;
