"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DriveCreationPrivacyParameters = exports.WalletTypeParameters = exports.CustomMetaDataParameters = exports.MetadataJsonParameter = exports.MetaDataGqlTagsParameter = exports.MetaDataFileParameter = exports.DataGqlTagsParameter = exports.IPFSParameter = exports.RemotePathParameter = exports.CustomContentTypeParameter = exports.GatewayParameter = exports.WithKeysParameter = exports.LocalCSVParameter = exports.LocalPathsParameter = exports.LocalPathParameter = exports.ShouldBundleParameter = exports.NoVerifyParameter = exports.AskParameter = exports.UpsertParameter = exports.ReplaceParameter = exports.SkipParameter = exports.DryRunParameter = exports.BoostParameter = exports.MaxDepthParameter = exports.AllParameter = exports.GetAllRevisionsParameter = exports.LocalFilesParameter_DEPRECATED = exports.DestinationManifestNameParameter = exports.DestinationFileNameParameter = exports.LocalFilePathParameter_DEPRECATED = exports.ParentFolderIdParameter = exports.FileIdParameter = exports.FolderIdParameter = exports.ConfirmationsParameter = exports.TransactionIdParameter = exports.DestinationAddressParameter = exports.TxFilePathParameter = exports.LastTxParameter = exports.RewardParameter = exports.ArAmountParameter = exports.DriveIdParameter = exports.AddressParameter = exports.DriveKeyParameter = exports.FileNameParameter = exports.FolderNameParameter = exports.DriveNameParameter = exports.UnsafeDrivePasswordParameter = exports.PrivateParameter = exports.SeedPhraseParameter = exports.WalletFileParameter = void 0;
exports.ConflictResolutionParams = exports.AllParameters = exports.TreeDepthParams = exports.DrivePrivacyParameters = void 0;
const parameter_1 = require("./CLICommand/parameter");
exports.WalletFileParameter = 'walletFile';
exports.SeedPhraseParameter = 'seedPhrase';
exports.PrivateParameter = 'private';
exports.UnsafeDrivePasswordParameter = 'unsafeDrivePassword';
exports.DriveNameParameter = 'driveName';
exports.FolderNameParameter = 'folderName';
exports.FileNameParameter = 'fileName';
exports.DriveKeyParameter = 'driveKey';
exports.AddressParameter = 'address';
exports.DriveIdParameter = 'driveId';
exports.ArAmountParameter = 'arAmount';
exports.RewardParameter = 'reward';
exports.LastTxParameter = 'lastTx';
exports.TxFilePathParameter = 'txFilePath';
exports.DestinationAddressParameter = 'destAddress';
exports.TransactionIdParameter = 'txId';
exports.ConfirmationsParameter = 'confirmations';
exports.FolderIdParameter = 'folderId';
exports.FileIdParameter = 'fileId';
exports.ParentFolderIdParameter = 'parentFolderId';
exports.LocalFilePathParameter_DEPRECATED = 'localFilePath';
exports.DestinationFileNameParameter = 'destFileName';
exports.DestinationManifestNameParameter = 'destManifestName';
exports.LocalFilesParameter_DEPRECATED = 'localFiles';
exports.GetAllRevisionsParameter = 'getAllRevisions';
exports.AllParameter = 'all';
exports.MaxDepthParameter = 'maxDepth';
exports.BoostParameter = 'boost';
exports.DryRunParameter = 'dryRun';
exports.SkipParameter = 'skip';
exports.ReplaceParameter = 'replace';
exports.UpsertParameter = 'upsert';
exports.AskParameter = 'ask';
exports.NoVerifyParameter = 'verify'; // commander maps --no-x style params to options.x and always includes in options
exports.ShouldBundleParameter = 'bundle'; // commander maps --no-x style params to options.x and always includes in options
exports.LocalPathParameter = 'localPath';
exports.LocalPathsParameter = 'localPaths';
exports.LocalCSVParameter = 'localCsv';
exports.WithKeysParameter = 'withKeys';
exports.GatewayParameter = 'gateway';
exports.CustomContentTypeParameter = 'contentType';
exports.RemotePathParameter = 'remotePath';
exports.IPFSParameter = 'addIpfsTag';
exports.DataGqlTagsParameter = 'dataGqlTags';
exports.MetaDataFileParameter = 'metadataFile';
exports.MetaDataGqlTagsParameter = 'metadataGqlTags';
exports.MetadataJsonParameter = 'metadataJson';
// Aggregates for convenience
exports.CustomMetaDataParameters = [
    exports.DataGqlTagsParameter,
    exports.MetaDataFileParameter,
    exports.MetaDataGqlTagsParameter,
    exports.MetadataJsonParameter
];
exports.WalletTypeParameters = [exports.WalletFileParameter, exports.SeedPhraseParameter];
exports.DriveCreationPrivacyParameters = [...exports.WalletTypeParameters, exports.PrivateParameter, exports.UnsafeDrivePasswordParameter];
exports.DrivePrivacyParameters = [exports.DriveKeyParameter, ...exports.DriveCreationPrivacyParameters];
exports.TreeDepthParams = [exports.AllParameter, exports.MaxDepthParameter];
exports.AllParameters = [
    exports.AddressParameter,
    exports.AllParameter,
    exports.ArAmountParameter,
    exports.BoostParameter,
    exports.ConfirmationsParameter,
    exports.CustomContentTypeParameter,
    exports.DataGqlTagsParameter,
    exports.DestinationAddressParameter,
    exports.DestinationFileNameParameter,
    exports.DriveKeyParameter,
    exports.DriveNameParameter,
    exports.DriveIdParameter,
    exports.DryRunParameter,
    exports.FileIdParameter,
    exports.FileNameParameter,
    exports.FolderIdParameter,
    exports.FolderNameParameter,
    exports.GatewayParameter,
    exports.GetAllRevisionsParameter,
    exports.LastTxParameter,
    exports.LocalFilePathParameter_DEPRECATED,
    exports.LocalFilesParameter_DEPRECATED,
    exports.LocalPathParameter,
    exports.LocalPathsParameter,
    exports.MaxDepthParameter,
    exports.MetaDataFileParameter,
    exports.MetaDataGqlTagsParameter,
    exports.MetadataJsonParameter,
    exports.ShouldBundleParameter,
    exports.NoVerifyParameter,
    exports.ParentFolderIdParameter,
    exports.PrivateParameter,
    exports.RewardParameter,
    exports.SeedPhraseParameter,
    exports.TransactionIdParameter,
    exports.TxFilePathParameter,
    exports.UnsafeDrivePasswordParameter,
    exports.WalletFileParameter,
    exports.WithKeysParameter,
    exports.RemotePathParameter,
    exports.IPFSParameter
];
exports.ConflictResolutionParams = [exports.SkipParameter, exports.ReplaceParameter, exports.UpsertParameter, exports.AskParameter];
/**
 * Note: importing this file will declare all the above parameters
 */
parameter_1.Parameter.declare({
    name: exports.WalletFileParameter,
    aliases: ['-w', '--wallet-file'],
    description: `the path to a JWK file on the file system representing your Arweave wallet
\t\t\t\t\t\t\t• Can't be used with --seed-phrase`,
    forbiddenConjunctionParameters: [exports.SeedPhraseParameter]
});
parameter_1.Parameter.declare({
    name: exports.SeedPhraseParameter,
    aliases: ['-s', '--seed-phrase'],
    description: `a 12-word seed phrase representing a JWK
\t\t\t\t\t\t\t• Can't be used with --wallet-file`,
    forbiddenConjunctionParameters: [exports.WalletFileParameter]
});
parameter_1.Parameter.declare({
    name: exports.UnsafeDrivePasswordParameter,
    aliases: ['-p', '--unsafe-drive-password'],
    description: `(OPTIONAL - NOT RECOMMENDED) the encryption password for the private drive
\t\t\t\t\t\t\t• When provided, creates/accesses a private drive. Public drive otherwise.
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --private
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --drive-key`,
    forbiddenConjunctionParameters: [exports.DriveKeyParameter, exports.PrivateParameter]
});
parameter_1.Parameter.declare({
    name: exports.PrivateParameter,
    aliases: ['-P', '--private'],
    description: `(OPTIONAL - RECOMMENDED OVER --unsafe-drive-password) specify to create/interact with private entities, i.e. drives, folders, and files
\t\t\t\t\t\t\t• obtains the drive password from the following locations, in precedence order:
\t\t\t\t\t\t\t\t- STDIN
\t\t\t\t\t\t\t\t- Environment variable ARDRIVE_DRIVE_PW
\t\t\t\t\t\t\t\t- Interactive, secure prompt
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --unsafe-drive-password
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --drive-key`,
    forbiddenConjunctionParameters: [exports.DriveKeyParameter, exports.UnsafeDrivePasswordParameter],
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.DriveKeyParameter,
    aliases: ['-k', '--drive-key'],
    description: `the base64 encoded symmetric encryption key (with '=' characters excised) for the drive (or parent drive in the case of folder operations)
\t\t\t\t\t\t\t• Required only for operations involving private drives or entities within them
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --unsafe-drive-password
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --private`,
    forbiddenConjunctionParameters: [exports.UnsafeDrivePasswordParameter, exports.PrivateParameter]
});
parameter_1.Parameter.declare({
    name: exports.DriveNameParameter,
    aliases: ['-n', '--drive-name'],
    description: `the name for the new drive`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.FolderNameParameter,
    aliases: ['-n', '--folder-name'],
    description: `the name for the new folder`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.FileNameParameter,
    aliases: ['-n', '--file-name'],
    description: `the new file name`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.AddressParameter,
    aliases: ['-a', '--address'],
    description: 'the 43-character Arweave wallet address to use for lookups'
});
parameter_1.Parameter.declare({
    name: exports.DriveIdParameter,
    aliases: ['-d', '--drive-id'],
    description: 'the ArFS entity ID associated with the target drive',
    required: true
});
parameter_1.Parameter.declare({
    name: exports.ArAmountParameter,
    aliases: ['-a', '--ar-amount'],
    description: `amount of AR to send to the --dest-address
\t\t\t\t\t\t\t• does NOT include transaction mining base rewards`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.RewardParameter,
    aliases: ['-r', '--reward'],
    description: `amount of Winston to set as the transaction reward`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.LastTxParameter,
    aliases: ['-l', '--last-tx'],
    description: `the transaction ID of the last transaction sent by this wallet`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.TxFilePathParameter,
    aliases: ['-x', '--tx-file-path'],
    description: `path on the filesystem from which to load the signed transaction data`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.DestinationAddressParameter,
    aliases: ['-d', '--dest-address'],
    description: 'the 43-character Arweave wallet address to which AR should be sent',
    required: true
});
parameter_1.Parameter.declare({
    name: exports.TransactionIdParameter,
    aliases: ['-t', '--tx-id'],
    description: 'The transaction id to check the status of in the mempool',
    required: true
});
parameter_1.Parameter.declare({
    name: exports.ConfirmationsParameter,
    aliases: ['-c', '--confirmations'],
    description: 'Number of confirmations to determine if a transaction is mined'
});
parameter_1.Parameter.declare({
    name: exports.ParentFolderIdParameter,
    aliases: ['-F', '--parent-folder-id'],
    description: `the ArFS folder ID for the folder in which this file will reside (i.e. its parent folder)
\t\t\t\t\t\t\t• To upload the file to the root of a drive, use the root folder ID of the drive`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.FolderIdParameter,
    aliases: ['-f', '--folder-id'],
    description: `the ArFS folder ID for the folder to query`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.FileIdParameter,
    aliases: ['-f', '--file-id'],
    description: `the ArFS file ID for the file to query`,
    required: true
});
parameter_1.Parameter.declare({
    name: exports.LocalFilePathParameter_DEPRECATED,
    aliases: ['-l', '--local-file-path'],
    description: `(DEPRECATED) the path on the local filesystem for the file that will be uploaded`
});
parameter_1.Parameter.declare({
    name: exports.LocalPathParameter,
    aliases: ['--local-path'],
    description: `the path on the local filesystem for the file that will be uploaded
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-files
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-paths
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-csv
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --remote-path`,
    forbiddenConjunctionParameters: [exports.LocalFilePathParameter_DEPRECATED, exports.LocalPathsParameter, exports.LocalCSVParameter]
});
parameter_1.Parameter.declare({
    name: exports.DestinationFileNameParameter,
    aliases: ['-d', '--dest-file-name'],
    description: `a destination file name to use when uploaded to ArDrive
\t\t\t\t\t\t\t• Required for use with --remote-path
\t\t\t\t\t\t\t• Optional when using with --local-path or --local-file-path`
});
parameter_1.Parameter.declare({
    name: exports.DestinationManifestNameParameter,
    aliases: ['-n', '--dest-manifest-name'],
    description: `(OPTIONAL) a destination file name for the manifest to use when uploaded to ArDrive`
});
parameter_1.Parameter.declare({
    name: exports.LocalFilesParameter_DEPRECATED,
    aliases: ['--local-files'],
    description: `(DEPRECATED) a path to a csv (tab delimited) file containing rows of data for the following columns:
\t\t\t\t\t\t\t• CSV Columns:
\t\t\t\t\t\t\t\t• local file path
\t\t\t\t\t\t\t\t• destination file name (optional)
\t\t\t\t\t\t\t\t• parent folder ID (optional)
\t\t\t\t\t\t\t\t\t• --parent-folder-id used, otherwise
\t\t\t\t\t\t\t\t• drive password (optional)
\t\t\t\t\t\t\t\t• drive key (optional)
\t\t\t\t\t\t\t• all parent folder IDs should reside in the same drive
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-paths
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-csv
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --dest-file-name
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --remote-path`,
    forbiddenConjunctionParameters: [
        exports.LocalFilePathParameter_DEPRECATED,
        exports.LocalPathParameter,
        exports.LocalPathsParameter,
        exports.LocalCSVParameter,
        exports.DestinationFileNameParameter
    ]
});
parameter_1.Parameter.declare({
    name: exports.GetAllRevisionsParameter,
    aliases: ['--get-all-revisions'],
    description: '(OPTIONAL) gets every revision of the entity',
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.BoostParameter,
    aliases: ['--boost'],
    description: '(OPTIONAL) a multiple of the base transaction mining reward that can be used to accelerate transaction mining. A multiple of 2.5 would boost a 100 Winston transaction reward to 250 Winston.'
});
parameter_1.Parameter.declare({
    name: exports.DryRunParameter,
    aliases: ['--dry-run'],
    description: '(OPTIONAL) Print the results of the transactions that would occur, and their potential tips and mining rewards, without sending the transactions.',
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.SkipParameter,
    aliases: ['--skip'],
    description: '(OPTIONAL) Skip upload if there is a name conflict within destination folder',
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.ReplaceParameter, exports.UpsertParameter, exports.AskParameter]
});
parameter_1.Parameter.declare({
    name: exports.ReplaceParameter,
    aliases: ['--replace'],
    description: '(OPTIONAL) Create new file revisions if there is a name conflict within destination folder',
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.SkipParameter, exports.UpsertParameter, exports.AskParameter]
});
parameter_1.Parameter.declare({
    name: exports.UpsertParameter,
    aliases: ['--upsert'],
    description: '(OPTIONAL) When there is a name conflict within the destination folder, only upload file if a modification is detected. Skip otherwise.',
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.SkipParameter, exports.ReplaceParameter, exports.AskParameter]
});
parameter_1.Parameter.declare({
    name: exports.AskParameter,
    aliases: ['--ask'],
    description: '(OPTIONAL) Show an interactive prompt to resolve name conflicts within the destination folder',
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.SkipParameter, exports.ReplaceParameter, exports.UpsertParameter]
});
parameter_1.Parameter.declare({
    name: exports.AllParameter,
    aliases: ['--all'],
    description: `(OPTIONAL) gets all contents within this folder, including child files/folders`,
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.MaxDepthParameter]
});
parameter_1.Parameter.declare({
    name: exports.MaxDepthParameter,
    aliases: ['--max-depth'],
    description: `(OPTIONAL) a non-negative integer value indicating the depth of the folder tree to list. 0 = specified folder's contents OR root folder for drives`
});
parameter_1.Parameter.declare({
    name: exports.NoVerifyParameter,
    aliases: ['--no-verify'],
    description: '(OPTIONAL) Derives a drive key for the given drive ID without verifying its correctness against the drive on chain.',
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.ShouldBundleParameter,
    aliases: ['--no-bundle'],
    description: '(OPTIONAL) Do not pack into a bundle; send as separate v2 transactions. NOT RECOMMENDED.',
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.LocalPathParameter,
    aliases: ['--local-path'],
    description: `the path on the local filesystem for the file that will be uploaded
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-files
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-paths
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-csv
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --remote-path`,
    forbiddenConjunctionParameters: [
        exports.LocalFilePathParameter_DEPRECATED,
        exports.LocalFilesParameter_DEPRECATED,
        exports.LocalPathsParameter,
        exports.LocalCSVParameter
    ]
});
parameter_1.Parameter.declare({
    name: exports.LocalPathsParameter,
    aliases: ['--local-paths'],
    type: 'array',
    description: `(BETA) a space-separated list of paths to files or folders to upload
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-files
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-csv
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --dest-file-name
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --remote-path`,
    forbiddenConjunctionParameters: [
        exports.LocalFilePathParameter_DEPRECATED,
        exports.LocalFilesParameter_DEPRECATED,
        exports.LocalPathParameter,
        exports.LocalCSVParameter,
        exports.DestinationFileNameParameter
    ]
});
parameter_1.Parameter.declare({
    name: exports.LocalCSVParameter,
    aliases: ['--local-csv'],
    description: `(BETA) a path to a csv (tab delimited) file containing rows of data for the following columns:
\t\t\t\t\t\t\t• CSV Columns:
\t\t\t\t\t\t\t\t• local file path
\t\t\t\t\t\t\t\t• destination file name (optional)
\t\t\t\t\t\t\t\t• parent folder ID (optional)
\t\t\t\t\t\t\t\t\t• --parent-folder-id used, otherwise
\t\t\t\t\t\t\t\t• drive password (optional)
\t\t\t\t\t\t\t\t• drive key (optional)
\t\t\t\t\t\t\t• all parent folder IDs should reside in the same drive
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-files
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-paths
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --dest-file-name
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --remote-path`,
    forbiddenConjunctionParameters: [
        exports.LocalFilePathParameter_DEPRECATED,
        exports.LocalFilesParameter_DEPRECATED,
        exports.LocalPathParameter,
        exports.LocalPathsParameter,
        exports.DestinationFileNameParameter
    ]
});
parameter_1.Parameter.declare({
    name: exports.WithKeysParameter,
    aliases: ['-K', '--with-keys'],
    description: `(OPTIONAL) displays the driveKey and fileKey of the listed entities`,
    type: 'boolean'
});
parameter_1.Parameter.declare({
    name: exports.GatewayParameter,
    aliases: ['-g', '--gateway'],
    description: `(OPTIONAL) a 'protocol://host:port' formatted string specifying the connection info for the Arweave gateway server to use`
});
parameter_1.Parameter.declare({
    name: exports.CustomContentTypeParameter,
    aliases: ['--content-type'],
    description: '(OPTIONAL) Provide a custom content type to all files within the upload to be used by the gateway to display the content'
});
parameter_1.Parameter.declare({
    name: exports.RemotePathParameter,
    aliases: ['--remote-path'],
    description: `the remote path for the file that will be uploaded
\t\t\t\t\t\t\t• MUST be used in conjunction with --dest-file-name
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-file-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-files
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-paths
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-path
\t\t\t\t\t\t\t• Can NOT be used in conjunction with --local-csv`,
    requiredConjunctionParameters: [exports.DestinationFileNameParameter],
    forbiddenConjunctionParameters: [
        exports.LocalFilePathParameter_DEPRECATED,
        exports.LocalPathsParameter,
        exports.LocalCSVParameter,
        exports.LocalPathParameter
    ]
});
parameter_1.Parameter.declare({
    name: exports.IPFSParameter,
    aliases: ['--add-ipfs-tag'],
    description: '(OPTIONAL) Computes the v1 IPFS content identifier (CID) for each file and sets it as the "IPFS-Add" tag value of each\'s respective file data transaction',
    type: 'boolean',
    forbiddenConjunctionParameters: [exports.PrivateParameter, exports.UnsafeDrivePasswordParameter]
});
parameter_1.Parameter.declare({
    name: exports.MetaDataFileParameter,
    aliases: ['--metadata-file'],
    description: '(OPTIONAL) Path to JSON file containing a custom metadata schema to add to ArFS transactions within the upload. Input must be a valid JSON object, e.g shape: `{ metaDataJson: { "TAG_NAME": [ "VAL_1", "VAL_2" ] }, metaDataGqlTags: { "IPFS-Add": "MY_PERMANENT_HASH?" } }`. Can NOT be used in conjunction with --metadata-json OR --metadata-gql-tags',
    forbiddenConjunctionParameters: [exports.MetadataJsonParameter, exports.MetaDataGqlTagsParameter, exports.DataGqlTagsParameter]
});
parameter_1.Parameter.declare({
    name: exports.MetadataJsonParameter,
    aliases: ['--metadata-json'],
    description: '(OPTIONAL) A stringified JSON input of custom fields in the `\'{"key": "val", "key-2": true, "key-3": 420, "key-4": ["more", 1337]}\'` format to be applied to the Data JSON of all MetaData Transactions created. Can NOT be used in conjunction with --metadata-file',
    forbiddenConjunctionParameters: [exports.MetaDataFileParameter]
});
parameter_1.Parameter.declare({
    name: exports.MetaDataGqlTagsParameter,
    aliases: ['--metadata-gql-tags'],
    type: 'array',
    description: '(OPTIONAL) A mapping of custom metadata in the `"TAG_NAME" "TAG_VALUE"` format to be applied to the GQL Tags of all MetaData Transactions created. Must be an even number of string values to determine custom metadata. Can NOT be used in conjunction with --metadata-file',
    forbiddenConjunctionParameters: [exports.MetaDataFileParameter]
});
parameter_1.Parameter.declare({
    name: exports.DataGqlTagsParameter,
    aliases: ['--data-gql-tags'],
    type: 'array',
    description: '(OPTIONAL) A list of custom Arweave tag name and value pairs in the format `"TAG_NAME" "TAG_VALUE"` that will be applied to all file data transactions created during an invocation. Must be an even number of string values. Can NOT be used in conjunction with --metadata-file',
    forbiddenConjunctionParameters: [exports.MetaDataFileParameter]
});
