declare type DownloadProgressCallback = (downloadProgress: number) => void;
declare type DownloadResult = {
    pathToFile: string;
    contentType: string;
};
/**
 * Downloads file from remote HTTP[S] host and puts its contents to the
 * specified location.
 * @param url URL of the file to download.
 * @param destinationPath Path to the destination file.
 * @param destinationFileName The file name.
 */
export declare function downloadFile(url: string, destinationPath: string, destinationFileName: string, downloadProgressCallback?: DownloadProgressCallback): Promise<DownloadResult>;
export {};
