/// <reference types="node" />
import { statSync } from 'fs';
export declare type FilePathAndName = [string, string?];
/**
 * Resolves the path, verifies its existance and type to conditionally return its dir and file name
 * @param {string} destOutputPath - the path from where to extract the dir path and name
 * @returns {FilePathAndName} - the directory where to put the file and the file name (which is undefined when the provided destOutputPath is a directory)
 */
export declare function getOutputFilePathAndName(destOutputPath: string, fsStatSyncAndPathResolveWrapper?: {
    statSync: typeof statSync;
    resolve: (...pathSegments: string[]) => string;
}): FilePathAndName;
/**
 * Resolves the path, verifies its existance and type to conditionally return its dir and file name
 * @param {string} destOutputPath - the path from where to extract the dir path and name
 * @param fsStatSyncAndPathResolveWrapper - for testing purposes it wraps the fs methods
 * @returns {FilePathAndName} - the directory where to put the file and the file name (which is undefined when the provided destOutputPath is a directory)
 */
export declare function getOutputFolderPathAndName(destOutputPath: string, fsStatSyncAndPathResolveWrapper?: {
    statSync: typeof statSync;
    resolve: (...pathSegments: string[]) => string;
}): FilePathAndName;
